#include <sys/vfs.h>
#include <time.h>
#include <FL/Fl_File_Chooser.H>
#include <FL/fl_ask.H>
#include <Fl/Fl_Pixmap.H>

typedef struct listrec{
	struct listrec *prev,*next;
	char name[PATH_MAX];
} listrec;

struct listrec *root,*last;
	int fuel=0;

char def_src_dir[PATH_MAX];
char def_dst_dir[PATH_MAX];


int run();

#include "Tank.xpm"
#include "ui.cxx"

static Fl_Pixmap p_tank(AB_Tank_xpm);
static Fl_RGB_Image img_icon(&p_tank,0);

UserInterface *ui;

int srchDir(const char* rootpath)
{
	DIR *dir;
	char path[PATH_MAX];
	struct dirent *de;
	struct listrec *act,*prev,*next;
	struct stat st;
	dir=opendir(rootpath);
	if(!dir) return -1;
	while(de=readdir(dir)){
		if(de->d_name[0]!='.'){
			sprintf(path,"%s/%s",rootpath,de->d_name);
			stat(path,&st);
			if(S_ISDIR(st.st_mode)){
				srchDir(path);
			}
			if(S_ISREG(st.st_mode)){
			next=(listrec*)calloc(1,sizeof(listrec));
			strcpy(next->name,path);
			if(root){
				last->next=next;
				next->prev=last;
			}
			else{
				root=next;
			}
			last=next;
			fuel++;
			}
		}
	}
	closedir(dir);
}

int df(const char* fsnam)
{
    struct statfs fs;
    statfs(fsnam,&fs);   
	return 100*fs.f_bfree/fs.f_blocks;
}

int outList()
{
	FILE *s,*d;
	char buf[0x10000],*cp;
	int r,los,max,rest,min_rest;
	double f;
	struct listrec *act,*prev,*next;
	char src[PATH_MAX],dst[PATH_MAX];

	max=fuel;
	ui->progress->minimum(0);
	ui->progress->maximum(fuel);
	min_rest=atoi(ui->min_free->value());
	while(fuel){
		f=random()*fuel;
		los=f/RAND_MAX;
		act=root;
		while(act&&los){
			act=act->next;
			los--;
		}
		if(act){
		strcpy(src,act->name);
		cp=strrchr(src,'/');
		if(!cp) return -1;
		cp++;
		rest=df(ui->dest->value());
		if(ui->btn_number->value())
			sprintf(dst,"%s/%04d-%s",ui->dest->value(),max-fuel,cp);
		else
			sprintf(dst,"%s/%s",ui->dest->value(),cp);
		ui->out_src->value(src);
		ui->out_dst->value(dst);
		ui->progress->value(max-fuel);
		if(rest<min_rest){
			ui->status->value("Zielmedium voll.");
			Fl::check();                           // give fltk some cpu to update the screen
		}
		else{
			sprintf(buf,"wird kopiert, %d von %d, Restkapazität auf Zielmedium: %d%%",max-fuel,max,rest);
			ui->status->value(buf);
			Fl::check();                           // give fltk some cpu to update the screen
			//printf("%s->%s\n",src,dst);
			s=fopen(src,"rb");
			if(!s) return -1;
			d=fopen(dst,"wb");
			if(!d) return -1;
			while(!feof(s)){
				r=fread(buf,1,0x10000,s);
				fwrite(buf,1,r,d);
			}
			fclose(s);
			fclose(d);
		}
		next=act->next;
		prev=act->prev;
		if(next) next->prev=prev;
		if(prev) prev->next=next;
		else root=next;
		}
		fuel--;
	}
	return 0;
}

int run()
{
	int c;
	ui->progress->show();
	ui->out_src->show();
	ui->out_dst->show();
	srandom(time(0));
	root=0;
	ui->status->value("Liste wird vorbereitet.");
	Fl::check();                           // give fltk some cpu to update the screen
	for(c=0;c<ui->browser->size();c++){
		srchDir(ui->browser->text(c+1));
	}
	outList();
	ui->status->value("Fertig!");
	ui->progress->hide();
	ui->out_src->hide();
	ui->out_dst->hide();
}

int main(int argc, char** argv)
{
	strcpy(def_src_dir,getenv("HOME"));
	sprintf(def_dst_dir,"/media/%s",getenv("USER"));
	ui=new UserInterface();
	ui->browser->type(FL_MULTI_BROWSER);
	ui->progress->hide();
	ui->out_src->hide();
	ui->out_dst->hide();
	ui->btn_number->value(1);
	ui->min_free->value("10");
	ui->win->default_icon(&img_icon);
	ui->win->show();
	return Fl::run();
}
